package it.sw.pa.comune.artegna.repository;

import it.sw.pa.comune.artegna.domain.Messaggio;
import java.util.List;
import java.util.Optional;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.*;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

/**
 * Spring Data JPA repository for the Messaggio entity.
 */
@Repository
public interface MessaggioRepository extends JpaRepository<Messaggio, Long> {
    default Optional<Messaggio> findOneWithEagerRelationships(Long id) {
        return this.findOneWithToOneRelationships(id);
    }

    default List<Messaggio> findAllWithEagerRelationships() {
        return this.findAllWithToOneRelationships();
    }

    default Page<Messaggio> findAllWithEagerRelationships(Pageable pageable) {
        return this.findAllWithToOneRelationships(pageable);
    }

    @Query(
        value = "select messaggio from Messaggio messaggio left join fetch messaggio.utente",
        countQuery = "select count(messaggio) from Messaggio messaggio"
    )
    Page<Messaggio> findAllWithToOneRelationships(Pageable pageable);

    @Query("select messaggio from Messaggio messaggio left join fetch messaggio.utente")
    List<Messaggio> findAllWithToOneRelationships();

    @Query("select messaggio from Messaggio messaggio left join fetch messaggio.utente where messaggio.id =:id")
    Optional<Messaggio> findOneWithToOneRelationships(@Param("id") Long id);
}
